/* filetest.c

  Routines to test the file functions needed for passfread.c

  compile with cc -o filetest filetest.c

  If you get errors from running the program, you should make sure that
  you comment out the #define PASSWORDS_ENABLED line in parse.c

  Jerry Bolton, Jr.
  31 October 1993

*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

#ifndef SEEK_SET
#define SEEK_SET 0
#endif

struct p_word {
    char name[50];
    char pword[50];
    int free;
};

struct p_word testrecord;
FILE *testfile;
int n;

main () {
    strcpy(testrecord.name,"Creel");
    strcpy(testrecord.pword,"Testing");
    testrecord.free = 0;
    testfile = fopen("filetest.dat","wb+");
    if (!testfile) {
	fprintf(stderr,"Error opening file.\n");
	return(0);
    };
    if (1 != fwrite(&testrecord, sizeof(struct p_word), 1,testfile)) {
	fprintf(stderr,"Error writing initial record.\n");
	return(0);
    };
    strcpy(testrecord.name,"Creel2");
    if (1 != fwrite(&testrecord, sizeof(struct p_word), 1,testfile)) {
	fprintf(stderr,"Error writing second record.\n");
	return(0);
    };
    fflush(testfile);
    if (fseek(testfile,0,SEEK_SET) != 0) {
	fprintf(stderr,"Error seeking beginning of file.\nSEEK_SET = %d\n",SEEK_SET);
	perror("filetest:");
	return(0);
    };
    n = fread(&testrecord, sizeof(struct p_word), 1, testfile);
    if (1 != n) {
	fprintf(stderr,"Error reading record 1.\n");
	fprintf(stderr,"fread() returned %d.\n",n);
	perror("filetest:");
	return(0);
    };
    printf("Record 1\n");
    printf("%s\n",testrecord.name);
    printf("%s\n",testrecord.pword);
    printf("%d\n",testrecord.free);
    n = fread(&testrecord, sizeof(struct p_word), 1, testfile);
    if (n != 1) {
	fprintf(stderr,"Error reading record 2.  %d \n",errno);
	return(0);
    };
    n = fread(&testrecord, sizeof(struct p_word), 1, testfile);
    if (n) {
	fprintf(stderr,"Error - end of file not detected.\n");
	return(0);
    };
    return(0);
};
